/*
 *  Functions for handling temporary files, for sort and shuffle programs.
 *  Steve Summit, scs@eskimo.com
 *  See http://www.eskimo.com/~scs/src for possible updates.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defs.h"
#include "tmpfile.h"

#ifndef TMPNAM
#define TMPDIR "/tmp"
#endif

extern char *progname;

struct tmpfile *
tfalloc()
{
struct tmpfile *tfp;

tfp = (struct tmpfile *)malloc(sizeof(struct tmpfile));

if(tfp == NULL)
	{
	fprintf(stderr, "%s: tfalloc: out of memory\n", progname);
	exit(1);
	}

tfp->tf_line = NULL;
tfp->tf_flags = 0;
tfp->tf_nents = 0;
tfp->tf_next = NULL;

return tfp;
}

#ifndef TMPNAM
static int nxtmpid = 1;
static char *tmpdir = NULL;
#endif

mktmpname(buf, unichar)
char *buf;
int unichar;
{
#ifdef TMPNAM

tmpnam(buf);

#else

char tmpfile[15];
static int pid;
static int havepid = FALSE;

if(tmpdir == NULL)
	{
	char *p;

	if((p = getenv("SORT_TMP")) != NULL)
		tmpdir = p;
	else if((p = getenv("TMP")) != NULL)
		tmpdir = p;
	else if((p = getenv("TMPDIR")) != NULL)
		tmpdir = p;
	else	tmpdir = TMPDIR;
	}

if(!havepid)
	{
	pid = getpid();
	havepid = TRUE;
	}

sprintf(tmpfile, "stm%d%c.%d", pid, unichar, nxtmpid++);

splicepath(buf, tmpdir, tmpfile);

#endif
}

#ifndef TMPNAM

splicepath(buf, dir, file)
char *buf;
char *dir, *file;
{
strcpy(buf, dir);
strcat(buf, "/");
strcat(buf, file);
}

#endif
