#ifndef TMPFILE_H
#define TMPFILE_H

#ifndef EOF
#include <stdio.h>
#endif

#ifdef DBSORT
#include <db.h>
#endif

#ifdef TMPNAM
#define TFNAMEMAX TMP_MAX
#else
#define TFNAMEMAX 40
#endif

struct tmpfile
	{
	char tf_filename[TFNAMEMAX];
	union	{
		FILE *tfu_fd;
#ifdef DBSORT
		struct dbfd *tfu_dbfd;
#endif
		} tf_fdu;
	union	{
		char *tfu_line;
#ifdef DBSORT
		dbnode tfu_dbnp;
#endif
		} tf_pu;
	int tf_flags;
	int tf_nents;
	struct tmpfile *tf_next;
	};

#define tf_fd tf_fdu.tfu_fd
#define tf_line tf_pu.tfu_line

#ifdef DBSORT
#define tf_dbfd tf_fdu.tfu_dbfd
#define tf_dbnp tf_pu.tfu_dbnp
#endif

#define TF_INUSE 0x01
#define TF_EOF	 0x02

#ifdef __STDC__
extern mktmpname(char *, int);
extern struct tmpfile *tfalloc(void);
#endif

extern struct tmpfile *tfalloc();

#endif
